#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Erzeuger-Verbraucher-Lösung mit Semaphore
# 

import time
from threading import *
from random import randint

class Lager:
    "Semaphoren-kontrolliertes Lager mit Mehrfachzugriff, Kapazität und Anzahl" 
    def __init__(self,kapazitaet,anzahl,maxZugriff):
        self.kapazitaet = kapazitaet
        self.anzahl     = anzahl
        self.zugriff    = Semaphore(maxZugriff)

class Erzeuger(Thread):

    def __init__(self,lager,warteZeit=1):
        "Erzeuger erzeugen"
        Thread.__init__(self)
        self.lager = lager
        self.warteZeit=warteZeit

    def run(self):
        "Erzeuger starten"
        while 1:                            # workaholic...
            self.lager.zugriff.acquire()    # Zugriff auf Lager anfordern
            wz = randint(1,self.warteZeit)  # Betriebspause per random im Intervall [1-warteZeit] ermitteln
            if self.lager.anzahl < self.lager.kapazitaet: # Verklemmungsschutz: ist noch Platz im Lager?
                self.lager.anzahl+=1        # dann erst Produkt erzeugen
                print "%s\t%ss\t -----> %s"%(currentThread().name,wz,self.lager.anzahl)
            self.lager.zugriff.release()    # Lager wieder freigeben
            time.sleep(wz)                  # warten, damit andere Erzeuger/Verbraucher tätig werden können


class Verbraucher(Thread):

    def __init__(self,lager,warteZeit=1):
        "Verbraucher erzeugen"
        Thread.__init__(self)
        self.lager = lager
        self.warteZeit=warteZeit

    def run(self):
        "Verbraucher starten"
        while 1:                            # immer auf Abruf...
            wz = randint(1,self.warteZeit)  # warteZeit per random berechnen
            self.lager.zugriff.acquire()    # Zugriff auf Lager anfordern
            if self.lager.anzahl:           # Verklemmungsschutz: ist Lager gefüllt?
                self.lager.anzahl-=1        # dann erst Produkt verbrauchen
                print "\t\t\t\t%s ----->\t%ss\t%s"%(self.lager.anzahl,wz,currentThread().name)
            self.lager.zugriff.release()    # Lager freigeben
            time.sleep(wz)                  # warten, damit andere Erzeuger/Verbraucher tätig werden können
        
        
        
if __name__=="__main__":

    bauteillager=Lager(10,0,1)              # Kapazität 10, Start 0, binäre Semaphore
    erz1=Erzeuger(bauteillager,6) 
    erz2=Erzeuger(bauteillager,3)
    ver1=Verbraucher(bauteillager,4)
    ver2=Verbraucher(bauteillager,5)
    erz1.start()
    erz2.start()
    ver1.start()
    ver2.start()
    
    while 1: pass
